package com.chelvc.framework.base.exception;

import java.util.Collections;
import java.util.Map;

import com.google.common.collect.ImmutableMap;
import lombok.NonNull;
import org.springframework.http.HttpStatus;

/**
 * 参数无效异常
 *
 * @author Woody
 * @date 2021/8/10
 */
public class ParameterInvalidException extends FrameworkException {
    public ParameterInvalidException() {
        this(Collections.emptyMap());
    }

    public ParameterInvalidException(@NonNull String parameter, @NonNull String message) {
        this(parameter, message, null);
    }

    public ParameterInvalidException(@NonNull String parameter, @NonNull String message, Throwable cause) {
        this(ImmutableMap.of(parameter, message), cause);
    }

    public ParameterInvalidException(@NonNull Map<String, String> errors) {
        this(errors, null);
    }

    public ParameterInvalidException(@NonNull Map<String, String> errors, Throwable cause) {
        super(HttpStatus.PRECONDITION_FAILED, HttpStatus.PRECONDITION_FAILED.getReasonPhrase(), errors, cause);
    }
}
