package com.chelvc.framework.base.jackson;

import java.io.IOException;

import com.chelvc.framework.common.model.Enumeration;
import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;
import com.google.common.collect.ImmutableMap;

/**
 * Jackson枚举对象结构化处理器
 *
 * @author Woody
 * @date 2023/9/2
 */
public class EnumerationFormatSerializer extends StdSerializer<Enumeration> {
    public EnumerationFormatSerializer() {
        super(Enumeration.class);
    }

    @Override
    public void serialize(Enumeration enumeration, JsonGenerator generator, SerializerProvider provider)
            throws IOException {
        generator.writeObject(ImmutableMap.of(
                "code", enumeration.getCode(), "description", enumeration.getDescription()
        ));
    }
}
